set more off
set graphics off


program Election
  args prov fname parties
  clear
  import delimited id province riding `parties' OTR ALL using "`fname'.csv", varnames(nonames)
  drop if province!="`prov'"
  generate vsum=CPC+LIB+NDP+GRP+BLQ
  generate vCPC=CPC/vsum
  generate vLIB=LIB/vsum
  generate vNDP=NDP/vsum
  generate vGRP=GRP/vsum
  generate vBLQ=BLQ/vsum
  if "`prov'" == "QC" {
    dirifit vCPC vLIB vNDP vGRP vBLQ
    scalar a5=exp(_b[ln_alpha5:_cons])
  }
  else {
    dirifit vCPC vLIB vNDP vGRP
    scalar a5=0
  }
  scalar a1=exp(_b[ln_alpha1:_cons])
  scalar a2=exp(_b[ln_alpha2:_cons])
  scalar a3=exp(_b[ln_alpha3:_cons])
  scalar a4=exp(_b[ln_alpha4:_cons])
  scalar s=a1+a2+a3+a4+a5
  scalar a1=a1/s
  scalar a2=a2/s
  scalar a3=a3/s
  scalar a4=a4/s
  scalar a5=a5/s
  di "Precision(`fname',`prov')=" %5.2f = s
  file write results %5s "`fname' "
  file write results %3s "`prov' "
  file write results %8.4f (s)
  file write results _newline
end


file open results using "canadian.txt", write replace

Election ON CA42 "CPC LIB NDP BLQ GRP"
Election MB CA42 "CPC LIB NDP BLQ GRP"
Election BC CA42 "CPC LIB NDP BLQ GRP"
Election AB CA42 "CPC LIB NDP BLQ GRP"
Election QC CA42 "CPC LIB NDP BLQ GRP"
Election SK CA42 "CPC LIB NDP BLQ GRP"


Election ON CA41 "CPC LIB NDP BLQ GRP"
Election MB CA41 "CPC LIB NDP BLQ GRP"
Election BC CA41 "CPC LIB NDP BLQ GRP"
Election AB CA41 "CPC LIB NDP BLQ GRP"
Election QC CA41 "CPC LIB NDP BLQ GRP"
Election SK CA41 "CPC LIB NDP BLQ GRP"

Election ON CA40 "CPC LIB NDP BLQ GRP"
Election MB CA40 "CPC LIB NDP BLQ GRP"
Election BC CA40 "CPC LIB NDP BLQ GRP"
Election AB CA40 "CPC LIB NDP BLQ GRP"
Election QC CA40 "CPC LIB NDP BLQ GRP"
Election SK CA40 "CPC LIB NDP BLQ GRP"

file close results

exit,clear

