//----------------------------------------------------------------------
// Estimate Dirichlet distribution parameters from voting data
//----------------------------------------------------------------------
set more off
set graphics off

program Election
  args year
  clear
  infile using USH-`year'
  drop if (D==0 | R==0)
  generate all=D+R
  generate sD=D/all
  generate sR=R/all
  summ sD sR
  dirifit sD sR
  scalar a1=exp(_b[ln_alpha1:_cons])
  scalar a2=exp(_b[ln_alpha2:_cons])
  scalar s=a1+a2
  scalar a1=a1/s
  scalar a2=a2/s
  di a1
  di a2
  di s
  file write results %4s "`year'"
  file write results %10.7f (a1)
  file write results %10.7f (a2)
  file write results %10.7f (s)
  file write results _newline
end

program Elections
  args fname
  file open results using "`fname'.txt", write replace
  forvalues year = 1976(2)2018 {
    Election `year'
  }
  file close results
end

Elections dirichlet
clear
import delimited year a1 a2 s using "dirichlet.txt", delimiters(" ")
summ s
exit,clear
