*------------------------------------------------------------------------+
| PR-OAC Electoral System - Simulation & Evaluation                      |
| (C) 2019 by Prof. Werner Antweiler, University of British Columbia     |
+------------------------------------------------------------------------;
options nocenter ls=80;
libname here '.';

proc means data=here.simulation noprint;
  by parties model;
  var rep0 rep1 rep2 gallagher;
  output out=summary
    mean=rep0avg rep1avg rep2avg GI_avg
    std=rep0std rep1std rep2std GI_std;
data labels;
  infile datalines dsd delimiter=',';
  length model $1;
  length label $16;
  input parties model $ label $;
  datalines;
2,A,60/40
2,B,52/48
3,A,55/35/10
3,B,45/35/20
3,C,40/35/25
5,A,50/20/15/10/5
5,B,40/25/20/10/5
5,C,30/25/20/15/10
;
proc sort data=labels;
  by parties model;
data summary;
  merge summary labels end=verylast;
  by parties model;
  file 'simulation.tex';
  if _N_=1 then do;
    put '\begin{tabularx}{\linewidth}{|clc|CCC|}';
    put '\hline';
    put '\multicolumn{3}{|c|}{Simulation Group}&';
    put '\multicolumn{3}{c|}{Voter Representation (\%)}\\';
    put '\hline';
    put 'Parties&Vote shares (\%)&FPTP $\mathcal{G}$-index&' @;
    put 'FPTP&single PR-OAC&dual PR-OAC\\';
    put '\hline';
  end;
  if first.parties and _N_>1 then put '\hline';
  put parties 1.0 '&' label $14. @;
  put '&' GI_avg 4.1 ' (' GI_std 3.1 ')' @;
  array m[*] rep0avg rep1avg rep2avg;
  array s[*] rep0std rep1std rep2std;
  do i=1 to 3;
    mm=m[i];
    ss=s[i];
    put '&' mm 5.2 ' (' ss 4.2 ')' @;
  end;
  put '\\';
  if verylast then do;
    put '\hline';
    put '\end{tabularx}';
  end;  
run;
