/*********************************************
 * OPL CPLEX Model - PR-OAC Electoral System
 * Author: Werner Antweiler
 * Instituton: University of British Columbia
 * Date: 2015-11-10
 *********************************************/
// Entities
{string} Parties = ...;
{string} Ridings = ...;
int Seats[Parties] = ...;
// Assignment
tuple Assignment {
  string party;
  string riding;
  int votes;
}
{Assignment} Nodes = ...;
// Decision Variables
dvar boolean X[Nodes];
// Objective Function
maximize sum(k in Nodes) (k.votes*X[k]);
// Constraints
subject to {
forall(p in Parties)
   sum(k in Nodes: k.party == p) (X[k]) == (2*Seats[p]);
forall(r in Ridings)
   sum(k in Nodes: k.riding == r) (X[k])==2;  
};  

execute DISPLAY_RESULTS{
  for(var k in Nodes)
    if (X[k]>0)
      writeln("ASSIGNED: ",k.riding," ",k.party," ",k.votes);
}
